
#include "tca/libc.h"

#include "tca.h"

void foohnd(TCA_REF_PTR ref, int32 *data)
{ int i=0;

  printf("%d\n", *data);
  if (*data == 1)
    tcaNullReply(ref);
  else
    tcaReply(ref, &i);
}

void bazhnd(TCA_REF_PTR ref, int32 *data)
{ int i=2;

  printf("%d\n", *data);
  if (*data == 1)
    tcaNullReply(ref);
  else 
    tcaReply(ref, &i);
}

void barhnd(TCA_REF_PTR ref, int32 *data)
{
  printf("bar (%d)\n", *data);
  printf("Press any key to continue:"); getchar();
  tcaSuccess(ref);
}

void actionhnd(TCA_REF_PTR ref, int32 *data)
{
  printf("action (%d)\n", *data);
  tcaSuccess(ref);
}

void blahhnd(TCA_REF_PTR ref, int32 *data)
{ 
  int two=2, zero=0;

  printf("blah (%d)\n", *data);
  
  tcaExpandGoal("baz", &two);
  tcaExpandGoal("baz", &zero);
  tcaSuccess(ref);
}

#if defined(VXWORKS)
m1(host)
char *host;
#else
void main(int argc, char **argv)
#endif
{ 
  int one=1;

#if defined(VXWORKS)
  tcaConnectModule("mtest1", host);
#else
  tcaConnectModule("mtest1", tcaServerMachine());
#endif

  tcaRegisterQuery("foo", "int", "boolean",foohnd);
  
  tcaRegisterGoal("baz", "int", bazhnd);
  
  tcaRegisterCommand("bar", "int", barhnd);

  tcaRegisterGoal("blah", "int", blahhnd);

  tcaRegisterCommand("action", "int", actionhnd);

  tcaWaitUntilReady();

  tcaExpandGoal("blah", &one);

  tcaModuleListen();
}
