/*****************************************************************************
 * PROJECT: TCA
 *
 * (c) Copyright Richard Goodwin, 1995. All rights reserved.
 *
 * FILE: x11Utils.h
 *
 * ABSTRACT:
 * 
 * This file provides routines having the X11 main loop handle tca events.
 *
 * 
 * $Source: /afs/cs.cmu.edu/project/TCA/Master/tcaV8/utils/x11Utils.h,v $ 
 * $Revision: 1.1 $
 * $Date: 1995/04/07 05:16:41 $
 * $Author: rich $
 *
 * REVISION HISTORY:
 *
 * $Log: x11Utils.h,v $
 * Revision 1.1  1995/04/07  05:16:41  rich
 * Added x11Utils to connect tca to the X11 main loop.
 * Added sim device to use in creating simulators.
 *
 *
 *****************************************************************************/

#ifndef X11_UTILS_LOADED
#define X11_UTILS_LOADED

void connectTCA_X11(XtAppContext app_context);

#endif
